using FastEndpoints;
using Knots.DTO.User;
using Microsoft.EntityFrameworkCore;

namespace Knots.Endpoints.User;


public class PatchUsernameEndpoint(KnotsDbContext db, AutoMapper.IMapper mapper) : Endpoint<UpdateUsernameDto>
{
    public override void Configure()
    {
        Patch("/users/{@Id}/username/");
        AllowAnonymous();
    }

    public override async Task HandleAsync(UpdateUsernameDto req, CancellationToken ct)
    {
        Models.User? databaseUser = await db.Users.SingleOrDefaultAsync(x => x.Id == req.Id, cancellationToken: ct);

        if (databaseUser is null)
        {
            await Send.NotFoundAsync(ct);
            return;
        }
        
        mapper.Map(req, databaseUser);

        await db.SaveChangesAsync(ct);
        await Send.NoContentAsync(ct);
    }
}